---
title: XPathResult.invalidIteratorState
slug: Web/API/XPathResult/invalidIteratorState
tags:
  - API
  - DOM XPath API
  - Property
  - Reference
  - XPath
  - XPathResult
---
<div>{{APIRef("DOM XPath")}}</div>

<p>The read-only <strong><code>invalidIteratorState</code></strong> property of the {{domxref("XPathResult")}} interface signifies that the iterator has become invalid. It is <code>true</code> if {{domxref("XPathResult.resultType")}} is <code>UNORDERED_NODE_ITERATOR_TYPE</code> or <code>ORDERED_NODE_ITERATOR_TYPE</code> and the document has been modified since this result was returned.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var<em> iteratorState</em> = <em>result</em>.invalidIteratorState;
</pre>

<h3 id="Return_Value">Return value</h3>

<p>A boolean value indicating whether the iterator has become invalid.</p>

<h2 id="Example">Example</h2>

<p>The following example shows the use of the <code>invalidIteratorState</code> property.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;div&gt;XPath example&lt;/div&gt;
&lt;p&gt;Iterator state: &lt;output&gt;&lt;/output&gt;&lt;/p&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">var xpath = "//div";
var result = document.evaluate(xpath, document, null, XPathResult.ANY_TYPE, null);
// Invalidates the iterator state
document.querySelector("div").remove();
document.querySelector("output").textContent = result.invalidIteratorState ? "invalid" : "valid";
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example', 400, 70)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("DOM3 XPath", "xpath.html#XPathResult-invalid-iterator-state", "XPathResult.invalidIteratorState")}}</td>
   <td>{{Spec2("DOM3 XPath")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.XPathResult.invalidIteratorState")}}</p>
</div>
